/*==========================================================================
 *
 *  Copyleft (C) 1996 Interactive Computer Graphics. All Rights "UN-Reserved".
 *
 *  File:       ddex.cpp
 *  Content:    Direct Draw example program.
 *				This is modified from ddex1.cpp wroten by Microsoft.
 *
 *	2002/10/7	Modified by dino
 ***************************************************************************/

#define NAME "DDExample"
#define TITLE "Direct Draw Example"

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include <ddraw.h>
#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>

char	str[80];
//	HUnDirectDrawαԭz󪺫ŧi
LPDIRECTDRAW            lpDD;           // DirectDraw Object
LPDIRECTDRAWSURFACE     lpDDSPrimary;   // DirectDraw Primary Surface
LPDIRECTDRAWSURFACE     lpDDSBack;      // DirectDraw Back Surface
DDSURFACEDESC			ddsd;			// DirectDraw Surface Descriptor
DDSCAPS					ddscaps;
IDirectDrawClipper		*Clipper;

BOOL                    bActive;        // is application active?
WORD					mColor = 0;
WORD					mScreenWidth	= 1024; // ùe
WORD					mScreenHeight	= 768;	// ù

void drawTriangle (HDC hDC, int X1, int Y1, int X2, int Y2, int X3, int Y3);
void repaint(HWND hWnd,HDC hDC);

void repaint(HWND hWnd,HDC hDC)
{
	DWORD	x,y ;
    RECT        rc;
	GetClientRect(hWnd, &rc);
//	IMPORTANT
//	HUSectionФjapbDirectDraw̭sSurface Buffer
//  NOTE : if pixel format color bit is 32 bits, then DWORD is used.
//  if pixel format color bit is 16 bits, then WORD is used. 
	
	// 32 bits color is assumed here.
	DWORD	*vmem = (DWORD *)ddsd.lpSurface ;	// NLockLSurfacevmem
	for(y=0; y < ddsd.dwHeight; y++)			// SurfaceCy]_lȬs^
	{
		for(x=0; x < ddsd.dwWidth; x++)			// SurfaceCx]_lȬs^
			vmem[x] = mColor ;					// N쪺vmemmȶWmColor]P16-bit)

		vmem += ddsd.lPitch/sizeof(DWORD) ;		// NvmemVSuface޿WU@C
		mColor += 50	;					// NC⪺
	}
	mColor = 0; // reset

	// Information Output
//	FILE *fp = fopen("test","w+");
//	fprintf(fp,"lpitch = %d\n", (int)ddsd.lPitch);
//	fprintf(fp,"width = %d\n", (int)ddsd.dwWidth);
//	fprintf(fp,"height = %d\n", (int)ddsd.dwHeight);
//	fclose(fp);

	// For every face
		// Transformation
		// Projection
		// Clipping
		// Transfer to screen coordinates

	// Example of drawing a triangle
	// You can use LineTo to draw wireframe

	drawTriangle(hDC, (rc.right + rc.left)/2, (rc.top + rc.bottom)/2-100,
				  (rc.right + rc.left)/2-100, (rc.top + rc.bottom)/2+100, 
				  (rc.right + rc.left)/2+100, (rc.top + rc.bottom)/2+100);

//  text setting
	SetTextAlign( hDC, TA_CENTER );
	SetBkColor( hDC, RGB( 57, 109, 165 ) );
	SetTextColor( hDC, RGB( 255, 255, 255 ) );
//  Write formatted data to a string
	sprintf( str, "%d", 1 );
//  Output text
	TextOut( hDC, 100, 50 , TEXT("Triangle Count :"), 16);
	TextOut( hDC, 160, 50, str, lstrlen( str ) );
}

void drawTriangle (HDC hDC, int X1, int Y1, int X2, int Y2, int X3, int Y3)
{
//	IMPORTANT
//	HUSectionФjapbDirectDraw̭ϥhdc@GDIIs
	MoveToEx (hDC, X1, Y1, NULL);
	LineTo (hDC, X2, Y2);
	LineTo (hDC, X3, Y3);
	LineTo (hDC, X1, Y1);
}


static void ReleaseObjects( void )
{
    if ( lpDD != NULL )
    {
        if ( lpDDSPrimary != NULL )
        {
            lpDDSPrimary->Release();
            lpDDSPrimary = NULL;
        }
		if(lpDDSBack != NULL) {
			lpDDSBack->Release();
			lpDDSBack = NULL;
		}

        lpDD->Release();
        lpDD = NULL;
    }
}


BOOL Fail( HWND hwnd,  char *szMsg )
{
    ReleaseObjects();
    OutputDebugString( szMsg );
    DestroyWindow( hwnd );
    return FALSE;
}

static void finiObjects( void )
{
    if( lpDD != NULL )
    {
        if( lpDDSPrimary != NULL )
        {
            lpDDSPrimary->Release();
            lpDDSPrimary = NULL;
        }
        lpDD->Release();
        lpDD = NULL;
    }
}


long FAR PASCAL WindowProc( HWND hWnd, UINT message, 
                            WPARAM wParam, LPARAM lParam )
{
//  PAINTSTRUCT ps;
//	HGDIOBJ		OldPen;
	DDBLTFX     ddbltfx;
    switch( message )
    {
    case WM_ACTIVATEAPP:
        bActive = wParam;
        break;

    case WM_CREATE:
		SetTimer(hWnd, 33/*TIMER_RATE*/, 1/*ANIMATION_INTERVAL*/, NULL);
        break;
	case WM_TIMER:
			// using timer message to render 
			ddbltfx.dwSize = sizeof( ddbltfx );
			ddbltfx.dwFillColor = 0x000000ff; // RGB 0, 0, 255

			// fill back buffer to black
			if ( FAILED( lpDDSBack->Blt(NULL, NULL, NULL,
			    DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx ) ) )
			{
					return Fail( hWnd, "Couldn't clear buffer." );
			}
			
			if(lpDDSBack->Lock(NULL, &ddsd, DDLOCK_WAIT,NULL)==DD_OK) {
							HDC hDC ;
							lpDDSBack->GetDC(&hDC) ;
							repaint(hWnd,hDC);
							lpDDSBack->ReleaseDC(hDC) ;			
				lpDDSBack->Unlock(NULL);
			}

			while(TRUE) {
				//DWORD hRet = lpDDSPrimary->Flip(NULL, 0);
				DWORD hRet = lpDDSPrimary->Blt(NULL,lpDDSBack,NULL,DDBLT_WAIT,NULL);
				if(hRet == DD_OK)
					break;
				if(hRet == DDERR_SURFACELOST) {
					hRet= lpDDSPrimary->Restore();
					if(hRet != DD_OK)
						break;
				}
				if(hRet != DDERR_WASSTILLDRAWING)
					break;
			}

		break;
		
    case WM_KEYDOWN:
        switch( wParam )
        {
        case VK_ESCAPE:
        case VK_F12:
            PostMessage(hWnd, WM_CLOSE, 0, 0);

		default:

            break;
        }
        break;

    case WM_PAINT:
        break;

    case WM_DESTROY:
        finiObjects();
        PostQuitMessage( 0 );
        break;
    }

    return DefWindowProc(hWnd, message, wParam, lParam);
}


static BOOL doInit( HINSTANCE hInstance, int nCmdShow )
{
    HWND                hwnd;
    WNDCLASS            wc;
    HRESULT             ddrval;
    char                buf[256] = {0};
	TCHAR szAppName[] = TEXT ("IDR_MENU") ;

//	Set up and register window class
    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = WindowProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(hInstance, IDI_APPLICATION) ;
    wc.hCursor = LoadCursor(NULL, IDC_ARROW) ;
    wc.hbrBackground = NULL;
    wc.lpszMenuName = szAppName;
    wc.lpszClassName = NAME;
    RegisterClass( &wc );

//	Create a window
    hwnd = CreateWindowEx(
        WS_EX_TOPMOST,
        NAME,
        TITLE,
        WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT,
        SW_SHOW,
//        GetSystemMetrics( SM_CXSCREEN ),
//        GetSystemMetrics( SM_CYSCREEN ),
		mScreenWidth,
		mScreenHeight,
        NULL,
        NULL,
        hInstance,
        NULL );

	FILE *file;
	file = fopen("Test","w+");

	fprintf(file, "%d %d\n",  GetSystemMetrics( SM_CXSCREEN ),
							  GetSystemMetrics( SM_CYSCREEN ));

	fclose(file);

    if(!hwnd)
        return FALSE;

    ShowWindow(hwnd, nCmdShow);
    UpdateWindow(hwnd);

	// Create the DirectDraw object.
    if ( FAILED( DirectDrawCreate( NULL, &lpDD, NULL ) ) )
	{
        return Fail( hwnd, "Couldn't create DirectDraw object." );
    }

    // Get exclusive mode.
	if ( FAILED( lpDD->SetCooperativeLevel( hwnd, DDSCL_NORMAL ) ) )
	{
        return Fail( hwnd, "Couldn't set cooperative level." );
    }

    // Create the primary surface.
    ddsd.dwSize = sizeof( ddsd );
    ddsd.dwFlags = DDSD_CAPS;
	//ddsd.dwHeight = GetSystemMetrics( SM_CYSCREEN ); 
    //ddsd.dwWidth = GetSystemMetrics( SM_CXSCREEN );
	ddsd.dwHeight = mScreenHeight; 
    ddsd.dwWidth = mScreenWidth;
    ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE|DDSCAPS_VIDEOMEMORY;
  
    if ( FAILED( lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL ) ) )
	{
		ddsd.ddsCaps.dwCaps &= ~DDSCAPS_VIDEOMEMORY;
		if ( FAILED( lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL ) ) ) {
	        return Fail( hwnd, "Couldn't create primary surface." );
		}
    }
	ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT | 
		           DDSD_WIDTH | DDSD_CKSRCBLT; 
    ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN||DDSCAPS_VIDEOMEMORY; 
    //ddsd.dwHeight = GetSystemMetrics( SM_CYSCREEN ); 
    //ddsd.dwWidth = GetSystemMetrics( SM_CXSCREEN );
	ddsd.dwHeight = mScreenHeight; 
    ddsd.dwWidth = mScreenWidth;

    if ( FAILED( lpDD->CreateSurface( &ddsd, &lpDDSBack, NULL ) ) )
	{
		ddsd.ddsCaps.dwCaps &= ~DDSCAPS_VIDEOMEMORY;
		if ( FAILED( lpDD->CreateSurface( &ddsd, &lpDDSBack, NULL ) ) ) {
					return Fail( hwnd, "Couldn't create off-screen one.\n" );
		}
	}

	ddrval = lpDD->CreateClipper(0,&Clipper,NULL);
    if (ddrval != DD_OK)
    {
	MessageBox(hwnd,"error","Create Clipper Failed\n",MB_OK);
	return FALSE;
    }

    ddrval = Clipper->SetHWnd(0,hwnd);
    if (ddrval != DD_OK)
    {
	MessageBox(hwnd,"error","Set HWnd Failed\n",MB_OK);
        return  FALSE;
    }    

    ddrval = lpDDSPrimary->SetClipper(Clipper);
    if (ddrval != DD_OK)
    {
        MessageBox(hwnd,"error","Set Clipper Failed\n",MB_OK);
        return FALSE;
    }
	return TRUE;}


int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                        LPSTR lpCmdLine, int nCmdShow)
{
    MSG         msg;

    lpCmdLine = lpCmdLine;
    hPrevInstance = hPrevInstance;

    if( !doInit( hInstance, nCmdShow ) )
    {
        return FALSE;
    }

    while (GetMessage(&msg, NULL, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return msg.wParam;

}


